package it.uniroma1.lcl;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.index.IndexWriter;


public class IndexWiki
{
	private String path;
	
	public IndexWiki(String path) { this.path = path; }
	
	public void index(String source) throws IOException
	{
		BufferedReader br = new BufferedReader(new FileReader(source));
		
		String untrimmedLine;
		boolean bText = false;
		StringBuffer text = null;
		String title = null, id = null;
	
		IndexWriter writer = new IndexWriter(path, new StandardAnalyzer(), true);
		
		while((untrimmedLine = br.readLine()) != null)
		{
			String line = untrimmedLine.trim();
			
			if (untrimmedLine.startsWith("    <id>"))
			{
				int idx = line.indexOf("</id>");
				id = line.substring(4, idx);
			}
			else if (line.startsWith("<title>"))
			{
				int idx = line.indexOf("</title>");
				title = line.substring(7, idx);
				if (bText) System.out.println(title);
			}
			else if (line.startsWith("<text"))
			{
				int idx = line.indexOf("/>");
				if (idx == -1)
				{
					idx = line.indexOf(">");
					line = line.substring(idx+1);
					
					bText = true;
					text = new StringBuffer();
				}
			}
			int endText = line.indexOf("</text");
			if (bText)
			{
				if (endText == -1) endText = line.length();
				else
				{
					bText = false;
	
					Document d = new Document();
					d.add(new Field("id", id, Field.Store.YES, Field.Index.UN_TOKENIZED));
					d.add(new Field("title", title, Field.Store.YES, Field.Index.UN_TOKENIZED));
					d.add(new Field("text", text.toString(), Field.Store.YES, Field.Index.TOKENIZED, Field.TermVector.WITH_POSITIONS_OFFSETS));
					writer.addDocument(d);
				}
				
				text.append(line.substring(0, endText));
				text.append("\n");
			}
		}
		
		writer.optimize();
		writer.close();
	}	
}
