package it.uniroma1.lcl;
import java.io.IOException;

import org.apache.lucene.index.Term;
import org.apache.lucene.search.BooleanClause;
import org.apache.lucene.search.BooleanQuery;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.TermQuery;


public class SearchWiki
{
	private IndexSearcher is;
	
	public SearchWiki(String path) throws IOException
	{
		is = new IndexSearcher(path);
	}
	
	public Hits search(String term) throws IOException
	{
		return search(new String[] {term});
	}
	
	public Hits search(String[] terms) throws IOException
	{
		BooleanQuery q = new BooleanQuery();
		for (String t : terms) q.add(new TermQuery(new Term("text", t)), BooleanClause.Occur.MUST);
		
		Hits hits = is.search(q);
		
		return hits;
	}
	
	public void close() throws IOException
	{
		is.close();
	}
}
