package it.uniroma1.lcl;
import org.apache.lucene.document.*;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.Term;
import org.apache.lucene.index.TermFreqVector;
import org.apache.lucene.index.TermPositionVector;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.spans.*;


public class Test
{
	static public void main(String[] args) throws Exception
	{
		IndexWiki iw = new IndexWiki("wiki_index");
		iw.index("/home/roberto/Risorse/Wiki/simplewiki-20080303-pages-meta-current.xml");
		
		IndexReader indexReader = IndexReader.open("wiki_index");

		SpanTermQuery antonio = new SpanTermQuery(new Term("text", "antonio"));
		SpanTermQuery meucci = new SpanTermQuery(new Term("text", "meucci"));
		SpanOrQuery or = new SpanOrQuery(new SpanQuery[] {antonio, meucci});
		
		SpanFirstQuery first = new SpanFirstQuery(or, 20);
		
		Spans spans = first.getSpans(indexReader);
		
		while(spans.next())
		{
			int docNumber = spans.doc();
			System.out.println(docNumber);
			Document doc = indexReader.document(docNumber);
			System.out.println(spans.start()+"-"+spans.end());
			String[] tokens = doc.getValues("text");
			
			// eventualmente stampa i token in "tokens"
			
			TermFreqVector tfv = indexReader.getTermFreqVector(docNumber, "text");
			TermPositionVector tpv = (TermPositionVector)tfv;
			
			String[] terms = tpv.getTerms();
			for (int k = 0; k < terms.length; k++)
			{
				int[] pos = tpv.getTermPositions(k);
				for (int p : pos)
				{
					if (p == spans.start())
					{
						System.out.println(terms[k]);
						break;
					}
				}
			}
		}
		System.out.println("---");

		SearchWiki is = new SearchWiki("wiki_index");
		Hits hits = is.search(new String[] { "information", "theory" });
		for (int k = 0; k < hits.length(); k++)
		{
			Document d = hits.doc(k);
			System.out.println("Score:"+hits.score(k));
			System.out.println("Id:"+d.get("id"));
			System.out.println("Title:"+d.get("title"));
		}
		
		is.close();
	}
}
